#pragma once

#ifndef __ShutterStream_Globals
#define __ShutterStream_Globals

#include <stdlib.h>
#include <stdint.h>

#ifdef SS_NATIVE_API

#ifdef _WIN32
#ifdef SHUTTERSTREAM_EXPORTS
#define SHUTTERSTREAM_API __declspec(dllexport)
#else
#define SHUTTERSTREAM_API __declspec(dllimport)
#endif

#include <windows.h>
#if defined(__cplusplus_winrt)
#define SS_REGISTER_PLUGIN_EXPORT extern "C" __declspec(dllexport)
#include <D2d1_2.h>
typedef Windows::UI::Xaml::Controls::Page^ SSUIFrameView;
typedef IWICBitmap* SSImageHandle;
typedef ID2D1DeviceContext1* SSPaintContext;
typedef Platform::String^ SSString;
#else //!__cplusplus_winrt
#include <string>
typedef std::string SSString;
typedef HWND SSUIFrameView;
#endif

#ifdef _DEBUG
#define SHS_DEBUG
#endif


#elif __APPLE__
#import "TargetConditionals.h"
#if TARGET_OS_IPHONE
#define SHUTTERSTREAM_API
#define SS_REGISTER_PLUGIN_EXPORT

#ifdef __OBJC__
@class UIView;
#else
typedef struct objc_object UIView;
#endif
typedef UIView* SSUIFrameView;
#else
#define SHUTTERSTREAM_API __attribute__((visibility("default")))
#define SS_REGISTER_PLUGIN_EXPORT extern "C"

#ifdef __OBJC__
@class NSView;
#else
typedef struct objc_object NSView;
#endif
typedef NSView* SSUIFrameView;
#endif

#ifdef __OBJC__
@class NSString;
#else
typedef struct objc_object NSString;
#endif

#include <CoreGraphics/CoreGraphics.h>
typedef NSString* SSString;
typedef CGContextRef SSPaintContext;
typedef CGImageRef SSImageHandle;

#ifdef DEBUG
#define SHS_DEBUG
#endif

#endif // __APPLE__

#else // !SS_NATIVE_API
#include <QtGui/QImage>
#include <QtGui/QPainter>
#include <QtQuick/QQuickItem>
#ifdef SHUTTERSTREAM_EXPORTS
#define SHUTTERSTREAM_API Q_DECL_EXPORT
#else
#define SHUTTERSTREAM_API Q_DECL_IMPORT
#endif
typedef QString SSString;
typedef QImage SSImageHandle;
typedef QQuickItem* SSUIFrameView;
typedef QPainter SSPaintContext;

#ifdef QT_DEBUG
#define SHS_DEBUG
#endif
#endif // !SS_NATIVE_API


#define SHUTTERSTREAM_MAJORVERSION	0x0007
#define SHUTTERSTREAM_MINORVERSION	0x0000

#endif
